console.log("THOMAC", "plugin is running!!!")

function decrypt(data) {
    const key = "efjbwe3g"
    let newData = ""
    for (let i = 0; i < data.length; i++) {
        let char = data[i];
        let code = char.charCodeAt(0);
        for (let j = 0; j < key.length; j++) {
            code ^= key.charCodeAt(j)
        }
        let newChar = String.fromCharCode(code)
        newData += newChar
    }
    return newData
}

function downloadDomImage(url, options, onComplete) {
    console.log("THOMAC", "downloadDomImage")

    const img = new Image();

    if (window.location.protocol !== 'file:') {
        img.crossOrigin = 'anonymous';
    }

    function loadCallback() {
        img.removeEventListener('load', loadCallback);
        img.removeEventListener('error', errorCallback);
        console.log("THOMAC", "loadCallback", img)
        if (onComplete) { onComplete(null, img); }
    }

    function errorCallback() {
        img.removeEventListener('load', loadCallback);
        img.removeEventListener('error', errorCallback);
        if (onComplete) { onComplete(new Error(cc.debug.getError(4930, url))); }
    }

    img.addEventListener('load', loadCallback);
    img.addEventListener('error', errorCallback);
    img.src = url;
    return img;
}

function downloadFile(url, options, onProgress, onComplete) {
    console.log("THOMAC", "downloadFile")

    const xhr = new XMLHttpRequest();
    const errInfo = `download failed: ${url}, status: `;

    xhr.open('GET', url, true);

    if (options.xhrResponseType !== undefined) { xhr.responseType = options.xhrResponseType; }
    if (options.xhrWithCredentials !== undefined) { xhr.withCredentials = options.xhrWithCredentials; }
    if (options.xhrMimeType !== undefined && xhr.overrideMimeType) { xhr.overrideMimeType(options.xhrMimeType); }
    if (options.xhrTimeout !== undefined) { xhr.timeout = options.xhrTimeout; }

    if (options.xhrHeader) {
        for (const header in options.xhrHeader) {
            xhr.setRequestHeader(header, options.xhrHeader[header]);
        }
    }

    xhr.onload = () => {
        if (xhr.status === 200 || xhr.status === 0) {
            if (onComplete) { onComplete(null, xhr.response); }
        } else if (onComplete) { onComplete(new Error(`${errInfo}${xhr.status}(no response)`)); }
    };

    if (onProgress) {
        xhr.onprogress = (e) => {
            if (e.lengthComputable) {
                onProgress(e.loaded, e.total);
            }
        };
    }

    xhr.onerror = () => {
        if (onComplete) { onComplete(new Error(`${errInfo}${xhr.status}(error)`)); }
    };

    xhr.ontimeout = () => {
        if (onComplete) { onComplete(new Error(`${errInfo}${xhr.status}(time out)`)); }
    };

    xhr.onabort = () => {
        if (onComplete) { onComplete(new Error(`${errInfo}${xhr.status}(abort)`)); }
    };

    xhr.send(null);

    return xhr;
}

const downloadBlob = (url, options, onComplete) => {
    console.log("THOMAC", "downloadBlob")

    options.xhrResponseType = 'blob';
    downloadFile(url, options, options.onFileProgress, onComplete);
};

const downloadImage = (url, options, onComplete) => {
    console.log("THOMAC", "downloadImage")
    // const func = sys.hasFeature(sys.Feature.IMAGE_BITMAP) && legacyCC.assetManager.allowImageBitmap ? downloadBlob : downloadDomImage;
    // func(url, options, onComplete);

    if (cc.sys.hasFeature(cc.sys.Feature.IMAGE_BITMAP) && legacyCC.assetManager.allowImageBitmap) {
        downloadBlob(url, options, (err, data) => {
            if (!err && onComplete) {
                // 解密
                data = decrypt(data)
                onComplete(err, data)
            }
        })
    }
    else {
        downloadFile(url, options, options.onFileProgress, (err, data) => {
            if (err) {
                if (onComplete) { onComplete(err, data) }
                return
            }
            // 解密
            data = decrypt(data)
            downloadDomImage(url, options, onComplete)
        });
    }
};

cc.assetManager.downloader.register({
    '.png': downloadImage,
    '.jpg': downloadImage,
    '.bmp': downloadImage,
    '.jpeg': downloadImage,
    '.gif': downloadImage,
    '.ico': downloadImage,
    '.tiff': downloadImage,
    '.webp': downloadImage,
    '.image': downloadImage,
});